(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('ngx-context', ['exports', '@angular/core', 'rxjs', 'rxjs/operators'], factory) :
    (factory((global['ngx-context'] = {}),global.ng.core,global.rxjs,global.rxjs.operators));
}(this, (function (exports,core,rxjs,operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++)
                if (e.indexOf(p[i]) < 0)
                    t[p[i]] = s[p[i]];
        return t;
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @param {?} obj
     * @return {?}
     */
    function isSubscribableOrPromise(obj) {
        return obj instanceof rxjs.Observable || obj instanceof rxjs.Subject || obj instanceof Promise;
    }
    /**
     * @param {?} input
     * @return {?}
     */
    function parseKeys(input) {
        return (Array.isArray(input) ? input : input.split(/\s+/)).filter(( /**
         * @param {?} key
         * @return {?}
         */function (key) { return key; }));
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @abstract
     * @template T
     */
    var AbstractContextConsumer = /** @class */ (function () {
        function AbstractContextConsumer(provider, target) {
            this.provider = provider;
            this.target = target;
            this.destroy$ = new rxjs.Subject();
            this._contextMap = {};
            this._consume = '';
            this.consumed = new Map();
        }
        Object.defineProperty(AbstractContextConsumer.prototype, "contextMap", {
            get: /**
             * @return {?}
             */ function () {
                return this._contextMap;
            },
            set: /**
             * @param {?} map
             * @return {?}
             */ function (map) {
                this._contextMap = map || {};
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractContextConsumer.prototype, "consume", {
            get: /**
             * @return {?}
             */ function () {
                return this._consume;
            },
            set: /**
             * @param {?} consume
             * @return {?}
             */ function (consume) {
                this._consume = consume || '';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(AbstractContextConsumer.prototype, "component", {
            get: /**
             * @return {?}
             */ function () {
                return this.target['_view'].component;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @protected
         * @return {?}
         */
        AbstractContextConsumer.prototype.init = /**
         * @protected
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var consumed = parseKeys(this.consume);
                this.provider.reset$
                    .pipe(operators.takeUntil(this.destroy$))
                    .subscribe(( /**
             * @return {?}
             */function () { return _this.ngOnChanges(); }));
                if (this.provider.provide.length)
                    this.provider.change$
                        .pipe(operators.takeUntil(this.destroy$), operators.startWith.apply(void 0, __spread(Array.from(this.provider.provided.keys()))), operators.filter(( /**
                 * @param {?} key
                 * @return {?}
                 */function (key) { return !!key; })))
                        .subscribe(( /**
                 * @param {?} providerKey
                 * @return {?}
                 */function (providerKey) { return _this.syncProperties(consumed, providerKey); }));
            };
        /**
         * @protected
         * @return {?}
         */
        AbstractContextConsumer.prototype.reset = /**
         * @protected
         * @return {?}
         */
            function () {
                var _this = this;
                this.consumed.forEach(( /**
                 * @param {?} value
                 * @param {?} key
                 * @return {?}
                 */function (value, key) {
                    _this.component[key] = value;
                }));
                this.consumed.clear();
            };
        /**
         * @protected
         * @param {?} consumed
         * @param {?} providerKey
         * @return {?}
         */
        AbstractContextConsumer.prototype.syncProperties = /**
         * @protected
         * @param {?} consumed
         * @param {?} providerKey
         * @return {?}
         */
            function (consumed, providerKey) {
                /** @type {?} */
                var key = this.provider.contextMap[providerKey] || providerKey;
                key = this.contextMap[key] || key;
                if (consumed.length && consumed.indexOf(key) < 0)
                    return;
                if (!this.consumed.has(key))
                    this.consumed.set(key, this.component[key]);
                this.component[key] = this.provider.component[providerKey];
                this.target.markForCheck();
            };
        /**
         * @return {?}
         */
        AbstractContextConsumer.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                if (this.initialized) {
                    this.destroy$.next();
                    this.reset();
                    if (this.target && this.provider)
                        this.init();
                }
            };
        /**
         * @return {?}
         */
        AbstractContextConsumer.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.destroy$.next();
            };
        /**
         * @return {?}
         */
        AbstractContextConsumer.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.initialized = true;
                this.ngOnChanges();
            };
        AbstractContextConsumer.propDecorators = {
            contextMap: [{ type: core.Input }],
            consume: [{ type: core.Input }]
        };
        return AbstractContextConsumer;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var ContextProviderComponent = /** @class */ (function () {
        function ContextProviderComponent(source) {
            this.source = source;
            this.initialized = false;
            this._contextMap = {};
            this._provide = '';
            this.provided = new Map();
            this.change$ = new rxjs.ReplaySubject(1);
            this.reset$ = new rxjs.Subject();
        }
        Object.defineProperty(ContextProviderComponent.prototype, "contextMap", {
            get: /**
             * @return {?}
             */ function () {
                return this._contextMap;
            },
            set: /**
             * @param {?} map
             * @return {?}
             */ function (map) {
                this._contextMap = map || {};
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContextProviderComponent.prototype, "provide", {
            get: /**
             * @return {?}
             */ function () {
                return this._provide;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */ function (value) {
                this._provide = value || '';
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(ContextProviderComponent.prototype, "component", {
            get: /**
             * @return {?}
             */ function () {
                return this.source['_view'].component;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @return {?}
         */
        ContextProviderComponent.prototype.init = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                setTimeout(( /**
                 * @return {?}
                 */function () {
                    /** @type {?} */
                    var THIS = _this;
                    /** @type {?} */
                    var context = new Map();
                    /** @type {?} */
                    var provided = parseKeys(_this.provide).filter(( /**
                     * @param {?} key
                     * @return {?}
                     */function (key) { return key && key in _this.component; }));
                    provided.forEach(( /**
                     * @param {?} key
                     * @return {?}
                     */function (key) {
                        if (isSubscribableOrPromise(_this.component[key])) {
                            _this.change$.next(key);
                            return;
                        }
                        /** @type {?} */
                        var propertyDescriptor = Object.getOwnPropertyDescriptor(_this.component, key) ||
                            Object.getOwnPropertyDescriptor((( /** @type {?} */(_this.component))).__proto__, key);
                        _this.provided.set(key, propertyDescriptor);
                        var value = propertyDescriptor.value, writable = propertyDescriptor.writable, getter = propertyDescriptor.get, setter = propertyDescriptor.set, prop = __rest(propertyDescriptor, ["value", "writable", "get", "set"]);
                        Object.defineProperty(_this.component, key, __assign({}, prop, { get: getter
                                ? ( /**
                                 * @return {?}
                                 */function () {
                                    return getter.call(this);
                                })
                                : ( /**
                                 * @return {?}
                                 */function () {
                                    return context.get(key);
                                }), set: setter
                                ? ( /**
                                 * @return {?}
                                 */function () {
                                    setter.apply(this, arguments);
                                    THIS.change$.next(key);
                                })
                                : ( /**
                                 * @param {?} newValue
                                 * @return {?}
                                 */function (newValue) {
                                    context.set(key, newValue);
                                    THIS.change$.next(key);
                                }) }));
                        _this.component[key] = value || _this.component[key];
                    }));
                }), 0);
            };
        /**
         * @private
         * @return {?}
         */
        ContextProviderComponent.prototype.reset = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                this.provided.forEach(( /**
                 * @param {?} propertyDescriptor
                 * @param {?} key
                 * @return {?}
                 */function (propertyDescriptor, key) {
                    /** @type {?} */
                    var value = _this.component[key];
                    Object.defineProperty(_this.component, key, propertyDescriptor);
                    _this.component[key] = value;
                }));
                this.provided.clear();
                this.change$.next('');
                this.reset$.next();
            };
        /**
         * @return {?}
         */
        ContextProviderComponent.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                if (this.initialized) {
                    this.reset();
                    if (this.source)
                        this.init();
                }
            };
        /**
         * @return {?}
         */
        ContextProviderComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.initialized = true;
                this.ngOnChanges();
            };
        ContextProviderComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'context-provider',
                        template: '<ng-content></ng-content>',
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        ContextProviderComponent.ctorParameters = function () {
            return [
                { type: core.ChangeDetectorRef, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
            ];
        };
        ContextProviderComponent.propDecorators = {
            contextMap: [{ type: core.Input }],
            provide: [{ type: core.Input }]
        };
        return ContextProviderComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var ContextConsumerComponent = /** @class */ (function (_super) {
        __extends(ContextConsumerComponent, _super);
        function ContextConsumerComponent(providerComponent, parent) {
            return _super.call(this, providerComponent, parent) || this;
        }
        ContextConsumerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'context-consumer',
                        template: '',
                        changeDetection: core.ChangeDetectionStrategy.OnPush,
                        encapsulation: core.ViewEncapsulation.None
                    }] }
        ];
        /** @nocollapse */
        ContextConsumerComponent.ctorParameters = function () {
            return [
                { type: ContextProviderComponent, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] },
                { type: core.ChangeDetectorRef, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
            ];
        };
        return ContextConsumerComponent;
    }(AbstractContextConsumer));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var ContextConsumerDirective = /** @class */ (function (_super) {
        __extends(ContextConsumerDirective, _super);
        function ContextConsumerDirective(providerComponent, host) {
            var _this = _super.call(this, providerComponent, host) || this;
            _this.consume = '';
            return _this;
        }
        ContextConsumerDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[contextConsumer]',
                    },] }
        ];
        /** @nocollapse */
        ContextConsumerDirective.ctorParameters = function () {
            return [
                { type: ContextProviderComponent, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] },
                { type: core.ChangeDetectorRef, decorators: [{ type: core.Optional }, { type: core.Host }] }
            ];
        };
        ContextConsumerDirective.propDecorators = {
            consume: [{ type: core.Input, args: ['contextConsumer',] }]
        };
        return ContextConsumerDirective;
    }(AbstractContextConsumer));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var Context = /** @class */ (function () {
        function Context() {
            this.$implicit = {};
        }
        return Context;
    }());
    var ContextDisposerDirective = /** @class */ (function () {
        function ContextDisposerDirective(tempRef, vcRef, provider) {
            this.tempRef = tempRef;
            this.vcRef = vcRef;
            this.provider = provider;
            this.destroy$ = new rxjs.Subject();
            this._dispose = '';
        }
        Object.defineProperty(ContextDisposerDirective.prototype, "dispose", {
            get: /**
             * @return {?}
             */ function () {
                return this._dispose;
            },
            set: /**
             * @param {?} dispose
             * @return {?}
             */ function (dispose) {
                this._dispose = dispose || '';
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @private
         * @return {?}
         */
        ContextDisposerDirective.prototype.init = /**
         * @private
         * @return {?}
         */
            function () {
                var _this = this;
                /** @type {?} */
                var disposed = parseKeys(this.dispose);
                this.provider.reset$
                    .pipe(operators.takeUntil(this.destroy$))
                    .subscribe(( /**
             * @return {?}
             */function () { return _this.ngOnChanges(); }));
                if (this.provider.provide.length)
                    this.provider.change$
                        .pipe(operators.takeUntil(this.destroy$), operators.startWith.apply(void 0, __spread(Array.from(this.provider.provided.keys()))), operators.filter(( /**
                 * @param {?} key
                 * @return {?}
                 */function (key) { return !!key; })))
                        .subscribe(( /**
                 * @param {?} providerKey
                 * @return {?}
                 */function (providerKey) { return _this.syncProperties(disposed, providerKey); }));
            };
        /**
         * @private
         * @return {?}
         */
        ContextDisposerDirective.prototype.reset = /**
         * @private
         * @return {?}
         */
            function () {
                this.view = this.vcRef.createEmbeddedView(this.tempRef, new Context());
            };
        /**
         * @private
         * @param {?} disposed
         * @param {?} providerKey
         * @return {?}
         */
        ContextDisposerDirective.prototype.syncProperties = /**
         * @private
         * @param {?} disposed
         * @param {?} providerKey
         * @return {?}
         */
            function (disposed, providerKey) {
                /** @type {?} */
                var key = this.provider.contextMap[providerKey] || providerKey;
                if (disposed.length && disposed.indexOf(key) < 0)
                    return;
                /** @type {?} */
                var value = this.provider.component[providerKey];
                this.view.context.$implicit[key] = value;
                this.view.context[key] = value;
                this.view.markForCheck();
            };
        /**
         * @return {?}
         */
        ContextDisposerDirective.prototype.ngOnChanges = /**
         * @return {?}
         */
            function () {
                this.ngOnDestroy();
                this.reset();
                if (this.provider && this.tempRef && this.vcRef)
                    this.init();
            };
        /**
         * @return {?}
         */
        ContextDisposerDirective.prototype.ngOnDestroy = /**
         * @return {?}
         */
            function () {
                this.destroy$.next();
                if (this.view)
                    this.vcRef.clear();
            };
        ContextDisposerDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[contextDisposer]',
                    },] }
        ];
        /** @nocollapse */
        ContextDisposerDirective.ctorParameters = function () {
            return [
                { type: core.TemplateRef, decorators: [{ type: core.Optional }] },
                { type: core.ViewContainerRef, decorators: [{ type: core.Optional }] },
                { type: ContextProviderComponent, decorators: [{ type: core.Optional }, { type: core.SkipSelf }] }
            ];
        };
        ContextDisposerDirective.propDecorators = {
            dispose: [{ type: core.Input, args: ['contextDisposer',] }]
        };
        return ContextDisposerDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxContextModule = /** @class */ (function () {
        function NgxContextModule() {
        }
        NgxContextModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            ContextConsumerComponent,
                            ContextConsumerDirective,
                            ContextDisposerDirective,
                            ContextProviderComponent,
                        ],
                        exports: [
                            ContextConsumerComponent,
                            ContextConsumerDirective,
                            ContextDisposerDirective,
                            ContextProviderComponent,
                        ],
                    },] }
        ];
        return NgxContextModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NgxContextModule = NgxContextModule;
    exports.ContextConsumerComponent = ContextConsumerComponent;
    exports.ContextConsumerDirective = ContextConsumerDirective;
    exports.ContextDisposerDirective = ContextDisposerDirective;
    exports.ContextProviderComponent = ContextProviderComponent;
    exports.ɵa = AbstractContextConsumer;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-context.umd.js.map